/* -*- mode:c++; coding: koi8-r -*- */

#ifndef __ExternalEnthropy_h__
#define __ExternalEnthropy_h__

/* $Id: ExternalEnthropy.hpp,v 1.1 2003/04/14 20:50:16 cher Exp $ */
/* Copyright (C) 2003 Alexander Chernov <cher@unicorn.cmc.msu.ru> */

/*
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 See the `COPYING' file for the full terms and conditions.
*/

#include "EnthropySource.hpp"
#include "ByteSource.hpp"
#include "BitSource.hpp"
#include "OpenError.hpp"
#include "ReadError.hpp"
#include "BadArgsError.hpp"

class ExternalEnthropy : public EnthropySource
{
protected:
  BitSource *src;

public:
  ExternalEnthropy(ByteSource *bsrc) throw (BadArgsError);
  ~ExternalEnthropy() throw ();

  double getDouble() throw (ReadError);
};

#endif /* __ExternalEnthropy_h__ */

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c++-font-lock-extra-types: ("[A-Z]\\sw*[a-z]\\sw*")
 * End:
 */
