/* -*- mode:c++; coding: koi8-r -*- */

/* $Id: PseudoEnthropy.cpp,v 1.1 2003/04/14 20:53:07 cher Exp $ */
/* Copyright (C) 2003 Alexander Chernov <cher@unicorn.cmc.msu.ru> */

/*
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.

 See the `COPYING' file for the full terms and conditions.
*/

#include "PseudoEnthropy.hpp"

#include "cephes.h"

PseudoEnthropy::PseudoEnthropy()
  throw ()
{
}

PseudoEnthropy::PseudoEnthropy(int a, int b, int c)
  throw ()
{
  if (a < 0) a = -a;
  if (b < 0) b = -b;
  if (c < 0) c = -c;
  cephes_srand(a, b, c);
}

PseudoEnthropy::~PseudoEnthropy()
  throw ()
{
}

double
PseudoEnthropy::getDouble()
  throw ()
{
  return cephes_drand() - 1.0;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c++-font-lock-extra-types: ("[A-Z]\\sw*[a-z]\\sw*")
 * End:
 */
